summaryrefslogtreecommitdiffstats
path: root/tests
diff options
context:
space:
mode:
authorKarel Zak2016-07-11 10:25:13 +0200
committerKarel Zak2016-07-11 10:25:13 +0200
commit078720a76f275fc7858d6a02a9c7dbe9df5127f1 (patch)
tree6ac3818c2de132d4c44574b5faf7e25d7a2d0cce /tests
parentcfisk: add /dev/vda as another default disk (diff)
downloadkernel-qcow2-util-linux-078720a76f275fc7858d6a02a9c7dbe9df5127f1.tar.gz
kernel-qcow2-util-linux-078720a76f275fc7858d6a02a9c7dbe9df5127f1.tar.xz
kernel-qcow2-util-linux-078720a76f275fc7858d6a02a9c7dbe9df5127f1.zip
tests: add chrt test
Signed-off-by: Karel Zak <kzak@redhat.com>
Diffstat (limited to 'tests')
-rw-r--r--tests/commands.sh1
-rw-r--r--tests/expected/schedutils/chrt0
-rw-r--r--tests/expected/schedutils/chrt-batch2
-rw-r--r--tests/expected/schedutils/chrt-deadline9
-rw-r--r--tests/expected/schedutils/chrt-fifo4
-rw-r--r--tests/expected/schedutils/chrt-idle2
-rw-r--r--tests/expected/schedutils/chrt-other2
-rw-r--r--tests/expected/schedutils/chrt-rr4
-rwxr-xr-xtests/ts/schedutils/chrt99
9 files changed, 123 insertions, 0 deletions
diff --git a/tests/commands.sh b/tests/commands.sh
index 5518dc306..a69c87e42 100644
--- a/tests/commands.sh
+++ b/tests/commands.sh
@@ -89,3 +89,4 @@ TS_CMD_UUIDD=${TS_CMD_UUIDD-"$top_builddir/uuidd"}
TS_CMD_UUIDGEN=${TS_CMD_UUIDGEN-"$top_builddir/uuidgen"}
TS_CMD_WHEREIS=${TS_CMD_WHEREIS-"$top_builddir/whereis"}
TS_CMD_WIPEFS=${TS_CMD_WIPEFS-"$top_builddir/wipefs"}
+TS_CMD_CHRT=${TS_CMD_CHRT-"$top_builddir/chrt"}
diff --git a/tests/expected/schedutils/chrt b/tests/expected/schedutils/chrt
new file mode 100644
index 000000000..e69de29bb
--- /dev/null
+++ b/tests/expected/schedutils/chrt
diff --git a/tests/expected/schedutils/chrt-batch b/tests/expected/schedutils/chrt-batch
new file mode 100644
index 000000000..f94fc6f5f
--- /dev/null
+++ b/tests/expected/schedutils/chrt-batch
@@ -0,0 +1,2 @@
+SCHED_BATCH
+0
diff --git a/tests/expected/schedutils/chrt-deadline b/tests/expected/schedutils/chrt-deadline
new file mode 100644
index 000000000..33d552706
--- /dev/null
+++ b/tests/expected/schedutils/chrt-deadline
@@ -0,0 +1,9 @@
+SCHED_DEADLINE
+0
+<removed>'s current runtime/deadline/period parameters: 13000/13000/13000
+SCHED_DEADLINE
+0
+<removed>'s current runtime/deadline/period parameters: 12000/12000/13000
+SCHED_DEADLINE
+0
+<removed>'s current runtime/deadline/period parameters: 10000/12000/13000
diff --git a/tests/expected/schedutils/chrt-fifo b/tests/expected/schedutils/chrt-fifo
new file mode 100644
index 000000000..4cfa07f17
--- /dev/null
+++ b/tests/expected/schedutils/chrt-fifo
@@ -0,0 +1,4 @@
+SCHED_FIFO
+1
+SCHED_FIFO
+99
diff --git a/tests/expected/schedutils/chrt-idle b/tests/expected/schedutils/chrt-idle
new file mode 100644
index 000000000..42a43cb1a
--- /dev/null
+++ b/tests/expected/schedutils/chrt-idle
@@ -0,0 +1,2 @@
+SCHED_IDLE
+0
diff --git a/tests/expected/schedutils/chrt-other b/tests/expected/schedutils/chrt-other
new file mode 100644
index 000000000..07013ea27
--- /dev/null
+++ b/tests/expected/schedutils/chrt-other
@@ -0,0 +1,2 @@
+SCHED_OTHER
+0
diff --git a/tests/expected/schedutils/chrt-rr b/tests/expected/schedutils/chrt-rr
new file mode 100644
index 000000000..b5ee90dec
--- /dev/null
+++ b/tests/expected/schedutils/chrt-rr
@@ -0,0 +1,4 @@
+SCHED_RR
+1
+SCHED_RR
+99
diff --git a/tests/ts/schedutils/chrt b/tests/ts/schedutils/chrt
new file mode 100755
index 000000000..31bc7fdaa
--- /dev/null
+++ b/tests/ts/schedutils/chrt
@@ -0,0 +1,99 @@
+#!/bin/bash
+#
+# This file is part of util-linux.
+#
+# This file is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This file is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+
+TS_TOPDIR="${0%/*}/../.."
+TS_DESC="chrt"
+
+. $TS_TOPDIR/functions.sh
+ts_init "$*"
+
+ts_check_test_command "$TS_CMD_CHRT"
+
+function do_chrt {
+ $TS_CMD_CHRT $* $TS_CMD_CHRT --pid 0 | sed 's/.* policy: //; s/.* priority: //' &>> $TS_OUTPUT
+}
+
+function skip_policy {
+ $TS_CMD_CHRT --max | grep $1 | grep 'priority' &> /dev/null
+ if [ $? == 1 ]; then
+ ts_skip_subtest "unsupported"
+ return 1
+ fi
+ return 0
+}
+
+function cleanup_output {
+ sed -i -e 's/pid [0-9]*/<removed>/' $TS_OUTPUT
+}
+
+
+ts_init_subtest "fifo"
+skip_policy SCHED_FIFO
+if [ $? == 0 ]; then
+ do_chrt --fifo 1
+ do_chrt --fifo 99
+ cleanup_output
+fi
+ts_finalize_subtest
+
+
+ts_init_subtest "batch"
+skip_policy SCHED_BATCH
+if [ $? == 0 ]; then
+ do_chrt --batch 0
+ cleanup_output
+fi
+ts_finalize_subtest
+
+
+ts_init_subtest "other"
+skip_policy SCHED_OTHER
+if [ $? == 0 ]; then
+ do_chrt --other 0
+ cleanup_output
+fi
+ts_finalize_subtest
+
+
+ts_init_subtest "rr"
+skip_policy SCHED_RR
+if [ $? == 0 ]; then
+ do_chrt --rr 1
+ do_chrt --rr 99
+ cleanup_output
+fi
+ts_finalize_subtest
+
+
+ts_init_subtest "idle"
+skip_policy SCHED_IDLE
+if [ $? == 0 ]; then
+ do_chrt --idle 0
+ cleanup_output
+fi
+ts_finalize_subtest
+
+
+ts_init_subtest "deadline"
+skip_policy SCHED_DEADLINE
+if [ $? == 0 ]; then
+ do_chrt --deadline --sched-period 13000 0
+ do_chrt --deadline --sched-period 13000 --sched-deadline 12000 0
+ do_chrt --deadline --sched-period 13000 --sched-deadline 12000 --sched-runtime 10000 0
+ cleanup_output
+fi
+ts_finalize_subtest
+
+ts_finalize